/* The game logic (No view code or direct user interaction)
The game is a "Guess the word" Game based on Mastermind*/

#pragma once
#include <string>

// to make the syntax Unreal friendly
using FString = std::string;
using int32 = int;

struct FBullCowCount
{
	int32 Bulls = 0;
	int32 Cows = 0;
};

enum class ELevelSelect
{
	Input_Too_High,
	Input_Too_Low,
	Input_Not_Number,
	Correct
};
enum class EGuessStatus
{
	Invalid_Status,
	OK,
	Not_Isogram,
	Not_Word,
	No_Numbers,
	Wrong_Length,
	Not_Lowercase
};

class FBullCowGame
{
public:
	FBullCowGame(); //constructor
	
	int32 GetMaxTries() const;
	FString GetMaxScore();
	int32 GetHiddenWordLength() const;
	int32 GetCurrentTry() const;
	void GetLevel(FString);
	bool IsGameWon() const;
	EGuessStatus CheckGuessValidity(FString) const; 
	ELevelSelect CheckValidLevelInput(FString)const;
	void NewWord();
	void Reset(); 
	// counts bulls and cows, and increases turn number, assuming valid guess
	FBullCowCount SubmitValidGuess(FString );
	

	// ^^ Please ignore this and focus on the interface above ^^
private:
	// See constructor for initialization
	int32 MyCurrentTry;
	FString MaxScore;
	FString MyHiddenWord;
	bool NotNumber(FString) const;
	bool bGameIsWon;
	bool IsIsogram(FString) const;
	bool IsLowerCase(FString) const;
};